separate (ErrorHandler.Conversions.ToString.Note)
procedure NoteExpl (E_Str   : in out E_Strings.T)

is
begin
   case Err_Num.ErrorNum is
      when 1 =>
         E_Strings.Append_String
            (E_Str => E_Str,
             Str   => "Issued when information flow analysis is not performed and when" &
              " modes were specified in the global annotation. It is a reminder" &
              " that the dependencies specified in this annotation" &
              " (including whether each variable is an import or an export) have" &
              " not been checked against the code, and may therefore be incorrect." &
              " (warning control file keyword: notes)");
      when 2 =>
         E_Strings.Append_String
            (E_Str => E_Str,
             Str   => "Issued as a reminder when information flow analysis is not" &
              " performed in SPARK 83. The dependencies specified in this annotation" &
              " have not been checked against the code, and may" &
              " therefore be incorrect. (warning control file keyword: notes)");
      when 3 =>
         E_Strings.Append_String
            (E_Str => E_Str,
             Str   => "Issued as a reminder that the declaration of the type Address" &
              " within the target configuration file" &
              " implicitly defines a deferred constant of type Null_Address." &
              " (warning control file keyword: notes)");
      when 4 =>
         E_Strings.Append_String
            (E_Str => E_Str,
             Str   => "Issued as a reminder that the declaration of the subtype" &
              " Priority within the target configuration file implicitly defines" &
              " a constant Default_Priority, of type Priority, with the value" &
              " (Priority'First + Priority'Last) / 2." &
              " (warning control file keyword: notes)");
      when others => null;
   end case;
end NoteExpl;
