-------------------------------------------------------------------------------
-- (C) Altran Praxis Limited
-------------------------------------------------------------------------------
--
-- The SPARK toolset is free software; you can redistribute it and/or modify it
-- under terms of the GNU General Public License as published by the Free
-- Software Foundation; either version 3, or (at your option) any later
-- version. The SPARK toolset is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-- Public License for more details. You should have received a copy of the GNU
-- General Public License distributed with the SPARK toolset; see file
-- COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
-- the license.
--
--=============================================================================

with SPARK_IO;

use type SPARK_IO.File_Type;

--# inherit CommandLineData,
--#         Date_Time,
--#         E_Strings,
--#         ScreenEcho,
--#         SPARK_IO,
--#         Version;

package File_Utils is

   type File_Types is (Dec_File, Rule_File, Other_File);

   procedure Print_A_Header (File        : in SPARK_IO.File_Type;
                             Header_Line : in String;
                             File_Type   : in File_Types);
   --# global in     CommandLineData.Content;
   --#        in out SPARK_IO.File_Sys;
   --# derives SPARK_IO.File_Sys from *,
   --#                                CommandLineData.Content,
   --#                                File,
   --#                                File_Type,
   --#                                Header_Line;

end File_Utils;
