-------------------------------------------------------------------------------
-- (C) Altran Praxis Limited
-------------------------------------------------------------------------------
--
-- The SPARK toolset is free software; you can redistribute it and/or modify it
-- under terms of the GNU General Public License as published by the Free
-- Software Foundation; either version 3, or (at your option) any later
-- version. The SPARK toolset is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-- Public License for more details. You should have received a copy of the GNU
-- General Public License distributed with the SPARK toolset; see file
-- COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
-- the license.
--
--=============================================================================

with SPARK_IO;

--# inherit CommandLineData,
--#         Dictionary,
--#         ErrorHandler,
--#         ExaminerConstants,
--#         LexTokenManager,
--#         SparkLex,
--#         SPARK_IO,
--#         SPExpectedSymbols,
--#         SPParserActions,
--#         SPParserGoto,
--#         SPProductions,
--#         SPRelations,
--#         SPSymbols,
--#         STree,
--#         SystemErrors;
package SPParser is
   procedure SPParse (ProgText     : in     SPARK_IO.File_Type;
                      MaxStackSize :    out Natural;
                      FileEnd      :    out Boolean);
   --# global in     CommandLineData.Content;
   --#        in     Dictionary.Dict;
   --#        in out ErrorHandler.Error_Context;
   --#        in out LexTokenManager.State;
   --#        in out SparkLex.Curr_Line;
   --#        in out SPARK_IO.File_Sys;
   --#        in out STree.Table;
   --# derives ErrorHandler.Error_Context,
   --#         FileEnd,
   --#         LexTokenManager.State,
   --#         SparkLex.Curr_Line,
   --#         SPARK_IO.File_Sys,
   --#         STree.Table                from CommandLineData.Content,
   --#                                         Dictionary.Dict,
   --#                                         ErrorHandler.Error_Context,
   --#                                         LexTokenManager.State,
   --#                                         ProgText,
   --#                                         SparkLex.Curr_Line,
   --#                                         SPARK_IO.File_Sys,
   --#                                         STree.Table &
   --#         MaxStackSize               from ;

end SPParser;
