-------------------------------------------------------------------------------
-- (C) Altran Praxis Limited
-------------------------------------------------------------------------------
--
-- The SPARK toolset is free software; you can redistribute it and/or modify it
-- under terms of the GNU General Public License as published by the Free
-- Software Foundation; either version 3, or (at your option) any later
-- version. The SPARK toolset is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-- Public License for more details. You should have received a copy of the GNU
-- General Public License distributed with the SPARK toolset; see file
-- COPYING3. If not, go to http://www.gnu.org/licenses for a complete copy of
-- the license.
--
--=============================================================================

-- packed version of SPLeftCorner.
separate (SPRelations)
function SPLeftCorner (Parent : SPSymbols.SPSymbol;
                       Child  : SPSymbols.SPSymbol) return Boolean is
   LowIndex, HighIndex : LeftCornerRange;
   Found               : Boolean;
begin
   if Parent in SPSymbols.SPTerminal then
      Found := False;
   else
      LowIndex  := LeftCornerRange ((RelTab (Parent) / Low) mod LowLim);
      HighIndex := LeftCornerRange ((RelTab (Parent) / High) mod HighLim);
      loop
         Found := LeftCorner (LowIndex) = Child;
         exit when Found or LowIndex = HighIndex;
         LowIndex := LowIndex + 1;
      end loop;
   end if;
   return Found;
end SPLeftCorner;
